{-# LANGUAGE ExplicitNamespaces, ScopedTypeVariables, TypeOperators #-}
module GEODE.Metadata.TSV.Header
  ( WithDefaultHeader(..)
  , for
  , getHeader
  , glue ) where

import Data.Csv (DefaultOrdered(..), Header, ToNamedRecord(..), ToRecord(..))
import Data.HashMap.Strict ((!))
import GEODE.Metadata.Types (type (@)(..))

newtype WithDefaultHeader a = WithDefaultHeader a

-- | An alias to shorten and make more intuitive the magic of
-- the DefaultOrdered class type
getHeader :: DefaultOrdered a => a -> Header
getHeader = headerOrder

-- | This is just `undefined`, but nicer to read and making more sense with the
-- type notation `(for :: SomeTypeOfYours)`
for :: DefaultOrdered a => a
for = undefined

instance (DefaultOrdered a, ToNamedRecord a) => ToRecord (WithDefaultHeader a) where
  toRecord (WithDefaultHeader a) = (toNamedRecord a !) <$> getHeader a

glue :: a -> b -> WithDefaultHeader (a @ b)
glue a b = WithDefaultHeader (a :@: b)
